Index: src/edu/ucsb/nceas/metacat/lsid/LSIDAuthorityMetaData.java
===================================================================
--- src/edu/ucsb/nceas/metacat/lsid/LSIDAuthorityMetaData.java	(revision 2903)
+++ src/edu/ucsb/nceas/metacat/lsid/LSIDAuthorityMetaData.java	(revision 2904)
@@ -84,64 +84,51 @@
                                     MetadataResponse.RDF_FORMAT);
     }
 
-    private ByteArrayInputStream doMetadataRequest(LSID lsid)
-                    throws LSIDServerException
-    {
-        logger.debug("getting metadata for lsid " + lsid.getLsid());
+    private ByteArrayInputStream doMetadataRequest(LSID lsid) throws
+        LSIDServerException {
+      logger.debug("getting metadata for lsid " + lsid.getLsid());
 
-        try {
+      try {
 
+        LSIDDataLookup myLookup = new LSIDDataLookup();
+        InputStream content = myLookup.lsidData(lsid);
+        InputStream content2 = myLookup.lsidData(lsid);
+        if (!isEML(content2)) {
+          content = getEML(lsid);
+        }
+        content2.close();
+        setCurrentLSID(lsid);
 
+        // based on the doctype choose the appropriate stylesheet
+        String styleSheetName = null;
+        String _docType = myLookup.getDocType(lsid);
 
-            LSIDDataLookup myLookup = new LSIDDataLookup();
-            InputStream content = myLookup.lsidData(lsid);
-            InputStream content2 = myLookup.lsidData(lsid);
-            if (!isEML(content2)) {
-                content = getEML(lsid);
-            }
-            content2.close();
-            setCurrentLSID(lsid);
-
-            // based on the doctype choose the appropriate stylesheet
-            String styleSheetName = null;
-            String _docType = myLookup.getDocType(lsid);
-
-            try {
-              ResourceBundle rb = ResourceBundle.getBundle("metacat-lsid");
-
-
-              for (Enumeration e =  rb.getKeys(); e.hasMoreElements() ;) {
-                System.out.println(e.nextElement());
-              }
-
-
-              styleSheetName = rb.getString(_docType.replaceAll(":",""));
-              logger.debug("the stylesheet: " + styleSheetName);
-
-              logger.debug("\n\nlsid is of type: " + _docType + " using stylesheet: "
-                           + styleSheetName + "\n\n");
-            }
-            catch (java.util.MissingResourceException mre) {
-              logger.warn("there is no style corresponding to: '" + _docType +
-                          "' -- using default");
-              styleSheetName = this.DEFAULT_STYLESHEET;
-              mre.getMessage();
-            }
-            InputStream styleSheet = getClass()
-                            .getResourceAsStream(styleSheetName);
-            TransformerFactory factory = TransformerFactory.newInstance();
-            Transformer transformer = factory
-                            .newTransformer(new StreamSource(styleSheet));
-            ByteArrayOutputStream out = new ByteArrayOutputStream();
-            transformer.transform(new StreamSource(content),
-                                  new StreamResult(out));
-            content.close();
-            clearState();
-            return new ByteArrayInputStream(out.toByteArray());
-        } catch (Exception e) {
-            throw new LSIDServerException(e, "Error transforming XML for: "
-                                             + lsid);
+        try {
+          ResourceBundle rb = ResourceBundle.getBundle("metacat-lsid");
+          styleSheetName = rb.getString(_docType.replaceAll(":", ""));
         }
+        catch (java.util.MissingResourceException mre) {
+          logger.warn("there is no style corresponding to: '" + _docType +
+                      "' -- using default");
+          styleSheetName = this.DEFAULT_STYLESHEET;
+          mre.getMessage();
+        }
+        InputStream styleSheet = getClass()
+            .getResourceAsStream(styleSheetName);
+        TransformerFactory factory = TransformerFactory.newInstance();
+        Transformer transformer = factory
+            .newTransformer(new StreamSource(styleSheet));
+        ByteArrayOutputStream out = new ByteArrayOutputStream();
+        transformer.transform(new StreamSource(content),
+                              new StreamResult(out));
+        content.close();
+        clearState();
+        return new ByteArrayInputStream(out.toByteArray());
+      }
+      catch (Exception e) {
+        throw new LSIDServerException(e, "Error transforming XML for: "
+                                      + lsid);
+      }
     }
 
     public static String getStringFromInputStream(InputStream input)