Index: lib/style/skins/knp/spatial/africa_frame_config.xml
===================================================================
--- lib/style/skins/knp/spatial/africa_frame_config.xml	(revision 3048)
+++ lib/style/skins/knp/spatial/africa_frame_config.xml	(revision 3049)
@@ -179,15 +179,15 @@
   </SetAoi-->
 
   <AoiMetacatQuery id="aoiMetacatQuery">
-	  <buttonBar>mainButtonBar</buttonBar>
-	  <targetModel>mainMap</targetModel>
-	  <mouseHandler>mainAoi</mouseHandler>
-	  <class>RadioButton</class>
-          <enabledSrc>/images/QueryEnable.png</enabledSrc>
-          <disabledSrc>/images/QueryDisable.png</disabledSrc>
-	  <tooltip xml:lang="en">select multiple datasets</tooltip>
-          <metacat>http://pmark.msi.ucsb.edu:8180/knb/metacat</metacat>
-          <skin>knp</skin>
+      <buttonBar>mainButtonBar</buttonBar>
+      <targetModel>mainMap</targetModel>
+      <mouseHandler>mainAoi</mouseHandler>
+      <class>RadioButton</class>
+      <enabledSrc>/images/QueryEnable.png</enabledSrc>
+      <disabledSrc>/images/QueryDisable.png</disabledSrc>
+      <tooltip xml:lang="en">select multiple datasets</tooltip>
+      <metacat>../../../../metacat</metacat>
+      <skin>knp</skin>
       <pixel_tolerance>5</pixel_tolerance>
   </AoiMetacatQuery>
   
Index: lib/style/skins/knb2/spatial/config.xml
===================================================================
--- lib/style/skins/knb2/spatial/config.xml	(revision 3048)
+++ lib/style/skins/knb2/spatial/config.xml	(revision 3049)
@@ -172,15 +172,9 @@
       <enabledSrc>/images/QueryEnable.png</enabledSrc>
       <disabledSrc>/images/QueryDisable.png</disabledSrc>
       <tooltip xml:lang="en">select multiple datasets</tooltip>
-      <!-- ############################################################### -->
-      <!-- ##   Edit these values to match your system and preferences  ##-->
-      <!-- ############################################################### -->
-
-        <metacat>http://pmark.msi.ucsb.edu:8180/knb_test/metacat</metacat>
-        <skin>default</skin>
-        <pixel_tolerance>5</pixel_tolerance>
-
-      <!-- ############################################################### -->
+      <metacat>../../../../metacat</metacat>
+      <skin>default</skin>
+      <pixel_tolerance>5</pixel_tolerance>
     </AoiMetacatQuery>
   </widgets>
   <skinDir>../../../../spatial/mapbuilder/lib/skin/default</skinDir>
Index: lib/style/common/spatial_templates/openlayers1/controls.html
===================================================================
--- lib/style/common/spatial_templates/openlayers1/controls.html	(revision 3048)
+++ lib/style/common/spatial_templates/openlayers1/controls.html	(revision 3049)
@@ -25,7 +25,7 @@
                 {layers: "modis,global_mosaic"});
 
             var metacat_wms = new OpenLayers.Layer.WMS( "Metacat Documents",
-                "http://pmark.msi.ucsb.edu:8180/knb_test/wms",
+                "../../../../wms",
                 {layers: "data_bounds,data_points",
                  transparent: "true", format: "image/png"} );
 
Index: lib/style/common/spatial_templates/spatial1/config.xml
===================================================================
--- lib/style/common/spatial_templates/spatial1/config.xml	(revision 3048)
+++ lib/style/common/spatial_templates/spatial1/config.xml	(revision 3049)
@@ -172,15 +172,9 @@
       <enabledSrc>/images/QueryEnable.png</enabledSrc>
       <disabledSrc>/images/QueryDisable.png</disabledSrc>
       <tooltip xml:lang="en">select multiple datasets</tooltip>
-      <!-- ############################################################### -->
-      <!-- ##   Edit these values to match your system and preferences  ##-->
-      <!-- ############################################################### -->
-
-        <metacat>http://pmark.msi.ucsb.edu:8180/knb_test/metacat</metacat>
-        <skin>default</skin>
-        <pixel_tolerance>5</pixel_tolerance>
-
-      <!-- ############################################################### -->
+      <metacat>../../../../metacat</metacat>
+      <skin>default</skin>
+      <pixel_tolerance>5</pixel_tolerance>
     </AoiMetacatQuery>
   </widgets>
   <skinDir>../../../../spatial/mapbuilder/lib/skin/default</skinDir>