Index: docs/user/metacatinstall.html
===================================================================
--- docs/user/metacatinstall.html	(revision 3213)
+++ docs/user/metacatinstall.html	(revision 3214)
@@ -64,7 +64,7 @@
    processor or higher.  The amount of disk space required depends on the
    size of your RDBMS tablespace (which should be at least 10 MB, 
    however Metacat itself requires only about 1 MB of free space after 
-   installation.  These instructions assume a Linux environment but may
+   installation).  These instructions assume a Linux environment but may
    work on other UNIX type environments, however this has not been tested.
   </p>
   <p class = "header">Additional Required Software</p>
@@ -94,8 +94,9 @@
 <tr>
 <td>
   <p class="header">Java</p>
-  <p>You'll need a recent Java SDK; j2sdk1.4.2 or later is required.  The latest metacat release
-  has been tested with the <a href="http://java.sun.com/javase/downloads/index.jsp">Sun J2SE Development Kit 5.0 </a>.  
+  <p>You'll need a recent Java SDK; J2SE 1.4.2 or later is required.  The latest metacat release
+  has been tested most extensively with <a href="http://java.sun.com/j2se/1.5.0/">J2SE 5.0</a>
+  and this is the recommended version.
   Make sure that JAVA_HOME environment variable is properly set and that both
   java and javac are on your PATH.
   </p>
@@ -166,8 +167,8 @@
   <p>
     Install Tomcat into the directory of your choice. The directory in which 
     you install Tomcat itself will be referred to as the "$CATALINA_HOME".
-    We recommend that you install Tomcat version 5.0.  More details about 
-    Tomcat installation is available <a href=" http://jakarta.apache.org/tomcat/index.html">here</a>.
+    We recommend that you install Tomcat version 5.5.  More details about 
+    Tomcat installation are available <a href=" http://jakarta.apache.org/tomcat/index.html">here</a>.
   </p>
  </td>
 </tr>
@@ -193,8 +194,10 @@
    <a href="@server@/software/download.html">download</a> a gzipped tar file
    from this site.
   </p>
-  <p><h2>Edit <code>build.properties</code> File</h2></p>
   <p>
+  
+  <h2>Edit <code>build.properties</code> File</h2></p>
+  <p>
    Once you have either checked out or unzipped and untarred the source
    distribution, you can begin the installation process.  Change into the 
    metacat directory and edit the file called "<code>build.properties</code>".  You will need 
@@ -202,16 +205,30 @@
    your system.
   </p>
   <p>
-  The properties that you will likely need to change will include 
-  <code>tomcat</code>, <code>tomcatversion</code>, <code>webapps</code>, 
-  <code>context</code>, <code>server</code>, <code>httpserver</code>, 
-  <code>database</code>, <code>jdbc-connect</code>, <code>jdbc-base</code>, 
-  <code>user</code>, <code>password</code>, <code>datafilepath</code>, 
-  <code>inlinedatafilepath</code>, <code>cvsroot</code>, 
-  <code>default-style</code>, and <code>administrators</code>. 
-  Each is described in detail in the table below.
+  The properties that you will likely need to change will include:
+  <ul>
+  <li><code>tomcat</code></li>
+  <li><code>deploy.dir</code></li>
+  <li><code>metacat.context</code></li> 
+  <li><code>config.hostname</code></li>
+  <li><code>config.port</code></li>
+  <li><code>config.port.https</code></li>
+  <li><code>ldapUrl</code></li>
+  <li><code>database</code></li>
+  <li><code>jdbc-connect</code></li>
+  <li><code>jdbc-base</code></li>
+  <li><code>user</code></li>
+  <li><code>password</code></li>
+  <li><code>datafilepath</code></li>
+  <li><code>inlinedatafilepath</code></li>
+  <li><code>default-style</code></li>
+  <li><code>administrators</code></li>
+  <li><code>authority.context</code></li>
+  <li><code>config.lsidauthority</code></li>
+  </ul>
+
+  Each is described in detail in the following table:
   </p>
-  Properties you will likely need to change:
   <br><br>
   <table border="1">
     <tr>
@@ -225,35 +242,24 @@
       <td>Default:&nbsp;&nbsp;
           <code>/usr/local/devtools/jakarta-tomcat</code>
       <br><br>Example:&nbsp;&nbsp;
-          <code>C:/Tomcat5</code></td>
+          <code>C:/Tomcat-5.5</code></td>
     </tr>
     <tr>
-      <td>tomcatversion</td>
-      <td>The tomcatversion property is the version of your Tomcat. You should 
-          put tomcat4, or tomcat5 here.
-      </td>
-      <td>Default:&nbsp;&nbsp;
-          <code>tomcat5</code>
-      <br><br>Example:&nbsp;&nbsp;
-          <code>tomcat5</code>
-      </td>
-    </tr>
-    <tr>
-      <td>webapps</td>
-      <td>The webapps property is the location in which your tomcat servlet 
-          contexts are installed. This is typically "TOMCAT_HOME/webapps",
-          where TOMCAT_HOME is the same value that you entered for the 'tomcat'
+      <td>deploy.dir</td>
+      <td>The deploy.dir property is the location in which your tomcat servlet 
+          contexts are deployed. This is typically "${tomcat}/webapps",
+          where ${tomcat} is the same value that you entered for the 'tomcat'
           property above.
       </td>
       <td>Default:&nbsp;&nbsp;
           <code>/var/www/org.ecoinformatics.knb</code>
       <br><br>Example:&nbsp;&nbsp;
-          <code>C:/Tomcat5/webapps</code>
+          <code>C:/Tomcat-5.5/webapps</code>
       </td>
     </tr>
     <tr>
-      <td>context</td>
-      <td>The context property is the name of the servlet context in which you 
+      <td>metacat.context</td>
+      <td>The metacat.context property is the name of the servlet context in which you 
           want Metacat to be installed. This will determine the installation 
           directory for the servlet and many of the URLs that are used to access
           the installed Metacat server.</td>
@@ -264,32 +270,38 @@
       </td>
     </tr>
     <tr>
-      <td>server</td>
-      <td>The server property is hostname of for the server on which Metacat is 
+      <td>config.hostname</td>
+      <td>The config.hostname property is the hostname of the server on which Metacat is 
           running (note that you should not include the 'http://' in the server 
-          property). The server setting should include the port number 
-          appended to the end if Tomcat is running stand-alone (see example).
+          property).
       </td>
       <td>Default:&nbsp;&nbsp;
          <code>knb.ecoinformatics.org</code>
       <br><br>Example:&nbsp;&nbsp;
-         <code>somehost.university.edu:8080</code>
+         <code>somehost.university.edu</code>
       </td>
     </tr>
     <tr>
-      <td>httpserver</td>
-      <td>httpserver is the plain HTTP address on which Metacat is running 
-          (note that you should not include the 'http://' in the httpserver 
-          property).
-          The httpserver setting should include the HTTP plain port number 
-          appended to the end if Tomcat is running stand-alone (see example).</td>
+      <td>config.port</td>
+      <td>The config.port property is the HTTP plain port number that is used to connect to Metacat.
+          If Tomcat is running stand-alone, the value will typically be 8080.</td>
       <td>Default:&nbsp;&nbsp;
-          <code>knb.ecoinformatics.org</code>
+          <code>80</code>
       <br><br>Example:&nbsp;&nbsp;
-          <code>somehost.university.edu:8080</code>
+          <code>8080</code>
       </td>
     </tr>
     <tr>
+      <td>config.port.https</td>
+      <td>The config.port.https property is the HTTP secure port number that is used to connect to Metacat.
+          If Tomcat is running stand-alone, the value will typically be 8443.</td>
+      <td>Default:&nbsp;&nbsp;
+          <code>80</code>
+      <br><br>Example:&nbsp;&nbsp;
+          <code>8443</code>
+      </td>
+    </tr>
+    <tr>
       <td>ldapUrl</td>
       <td>URL to the LDAP server. The LDAP server is used in the default
           authentication module to authenticate and identify users of the
@@ -305,15 +317,15 @@
       <td>database</td>
       <td>Select the database to use for metadata storage.
           Valid values are <code>oracle</code>, <code>postgresql</code>, or
-          <code>sqlserver</code>. Note that sqlserver support is minimal and
+          <code>sqlserver</code>. <em>Note that sqlserver support is minimal and
           probably will not work without substantial changes on your part,
-          possibly including code changes.  We have not revcently tested on 
-          sqlserver.
+          possibly including code changes.  We have not recently tested on 
+          sqlserver.</em>
       </td>
       <td>Default:&nbsp;&nbsp;
-          <code>oracle</code>
+          <code>postgresql</code>
       <br><br>Other possible values:&nbsp;&nbsp;
-          <code>postgresql</code>&nbsp;&nbsp;
+          <code>oracle</code>&nbsp;&nbsp;
           <code>sqlserver</code>
       </td>
     </tr>
@@ -321,25 +333,28 @@
       <td>jdbc-connect</td>
       <td>The JDBC connection string used to connect to the database.</td>
       <td>Default:&nbsp;&nbsp;
-          <code>jdbc:oracle:thin:@metacat.nceas.ucsb.edu:1521:knb</code>
+          <code>jdbc-connect=jdbc:postgresql://localhost/metacat</code>
+      <br><br>Example:&nbsp;&nbsp;
+          <code>jdbc:oracle:thin:@somehost.university.edu:1521:metacat</code>
       </td>
     <tr>
       <td>jdbc-base</td>
-      <td>The base directory for locating JDBC jar files (not needed for postgresql).</td>
+      <td>The base directory for locating JDBC jar files. When using the postgresql database, the default setting of './lib' can be used,
+          while oracle and sqlserver databases will require a different setting since these jar files are not included in the Metacat
+          distribution.</td>
       <td>Default:&nbsp;&nbsp;
-          <code>/usr/oracle/jdbc/lib</code>
+          <code>./lib</code>
       <br><br>Example:&nbsp;&nbsp;
-          <code>C:/jdev10g/jdbc/lib</code><br>
+          <code>/usr/oracle/jdbc/lib</code><br>
       </td>
     </tr>
     <tr>
       <td>user</td>
-      <td>The database user name that you set up to use Metacat. For example, 
-          an Oracle username.</td>
+      <td>The database user name that you set up to use Metacat.</td>
       <td>Default:&nbsp;&nbsp;
-          <code>knb</code>
+          <code>metacat</code>
       <br><br>Example:&nbsp;&nbsp;
-          <code>metacatdb</code>
+          <code>metacatuser</code>
       </td>
     </tr>
     <tr>
@@ -357,7 +372,7 @@
       <td>Default:&nbsp;&nbsp;
           <code>/var/metacat/data</code>
       <br><br>Example:&nbsp;&nbsp;
-          <code>C:/Tomcat5/data/knb/data</code>
+          <code>C:/Tomcat-5.5/data/metacat/data</code>
       </td>
     </tr>
     <tr>
@@ -367,7 +382,7 @@
       <td>Default:&nbsp;&nbsp;
           <code>/var/metacat/inline-data</code>
       <br><br>Example:&nbsp;&nbsp;
-          <code>C:/Tomcat5/data/knb/inlinedata</code>
+          <code>C:/Tomcat-5.5/data/metacat/inlinedata</code>
       </td>
     </tr>
     <tr>
@@ -374,13 +389,12 @@
       <td>default-style</td>
       <td>The default-style parameter defines the "style-set" that is to be used
           by default when the qformat parameter is missing or set to "html"
-          during a query. It is set to "knb", which is one of the styles that 
+          during a query. It is set to "default", which is one of the styles that 
           ships with the default metacat distribution. Other possible settings
           are shown in the examples to the right.</td>
       <td>Default:&nbsp;&nbsp;
-          <code>knb</code>
-      <br><br>Examples:&nbsp;&nbsp;
-          <pre><code>default   esa   knb2   nceas   nrs   obfs   specnet</code></pre>
+          <code>default</code>
+      <br><br>Examples:<code>esa kepler knb knb2 knp lter ltss nceas nrs obfs pisco specnet</code>
       </td>
     </tr>
     <tr>
@@ -387,7 +401,7 @@
       <td>administrators</td>
       <td>The administrators parameter lists the accounts that are allowed to
           perform administrative actions such as rebuilding indices for 
-          documents. The list can can contain more than one account separated
+          documents. The list can contain more than one account separated
           by colons.</td>
       <td>Default:&nbsp;&nbsp;
           <code>uid=jones,o=NCEAS,dc=ecoinformatics,dc=org</code>
@@ -440,10 +454,20 @@
       <td>cgi-prefix</td>
       <td>&nbsp;</td>
       <td>Default:&nbsp;&nbsp;
-          <code>http://knb.ecoinformatics.org/cgi-bin</code>
+          <code>http://${httpserver}/cgi-bin</code>
       </td>
     </tr>
     <tr>
+      <td>cvsroot</td>
+      <td>CVS access to retrieve latest EML. Only used by
+          developers in building the release.</td>
+      <td>Default:&nbsp;&nbsp;
+          <code><pre>:ext:${env.USER}@cvs.ecoinformatics.org:/cvs</pre></code>
+          Example:&nbsp;&nbsp;
+          <code><pre>:ext:myaccount@cvs.ecoinformatics.org:/cvs</pre></code>
+      </td>
+    </tr>
+    <tr>
       <td>knb-site-url</td>
       <td>This is the URL to the web context root for the knb site. 
           It is used for the qformat=knb skin only.</td>
@@ -452,6 +476,33 @@
       </td>
     </tr>
     <tr>
+      <td>timedreplication</td>
+      <td>Determines whether timed replication to other metacat servers is being used.</td>
+      <td>Default:&nbsp;&nbsp;
+          <code>false</code>
+      <br><br>Other possible values:&nbsp;&nbsp;
+          <code>true</code>
+      </td>
+    </tr>
+    <tr>
+      <td>firsttimedreplication</td>
+      <td>The time for starting first timed replication if timedreplication is true.
+          (See comments in build.properties file for additional details.)</td>
+      <td>Default:&nbsp;&nbsp;
+          <code>10:00 PM</code>
+          <code>&nbsp;</code>
+      </td>
+    </tr>
+    <tr>
+      <td>timedreplicationinterval</td>
+      <td>The interval to next timed replication if timedreplication is true.
+          The value is in milliseconds and default value is 48 hours.</td>
+      <td>Default:&nbsp;&nbsp;
+          <code>172800000</code>
+          <code>&nbsp;</code>
+      </td>
+    </tr>
+    <tr>
       <td>forcereplicationwaitingtime</td>
       <td>The waiting time before replication is forced to begin after
           uploading a package. The default value should usually suffice.</td>
@@ -460,20 +511,10 @@
           <code>&nbsp;</code>
       </td>
     </tr>
-    <tr>
-      <td>cvsroot</td>
-      <td>CVS access to retrieve latest EML. Only used by
-          developers in building the release.</td>
-      <td>Default:&nbsp;&nbsp;
-          <code><pre>:ext:${env.USER}@cvs.ecoinformatics.org:/cvs</pre></code>
-          Example:&nbsp;&nbsp;
-          <code><pre>:ext:myaccount@cvs.ecoinformatics.org:/cvs</pre></code>
-      </td>
-    </tr>
   </table>
   <p>
   Metacat has a number of additional settable properties in file
-  <code>metacat/lib/metacat.properties</code>. Under most circumstances,
+  <code>lib/metacat.properties</code>. Under most circumstances,
   you will not need to modify this file because the properties of interest
   to you can be controlled by editing <code>build.properties</code> as
   described above. To learn more about Metacat's additional properties,
@@ -602,16 +643,17 @@
       <li>build/src/upgrade-db-to-1.3.sql</li>
       <li>build/src/upgrade-db-to-1.4.sql</li>
       <li>build/src/upgrade-db-to-1.5.sql</li>
+      <li>build/src/upgrade-db-to-1.6.sql</li>
+      <li>build/src/upgrade-db-to-1.7.sql</li>
     </ul>
    <p>
-    So, if you had an existing metacat 1.0 installation and you were upgrading 
-    to 1.5, you would need to run all four scripts in sequence:
-    upgrade-db-to-1.2.sql, upgrade-db-to-1.3.sql, 
-    upgrade-db-to-1.4.sql, and upgrade-db-to-1.5.sql. 
-    However, if you were starting from a Metacat 1.4.x
-    installation, you would only need to run the upgrade-db-to-1.5.sql script.
-    Be sure to use the version of the scripts from the 'build' directory: they
-    are customized for your installation in that directory.
+    For example, if you had an existing metacat 1.4 installation and you were upgrading 
+    to metacat 1.7, you would need to run three scripts in sequence:
+    upgrade-db-to-1.5.sql, upgrade-db-to-1.6.sql, and upgrade-db-to-1.7.sql. 
+    However, if you were starting from a Metacat 1.6
+    installation, you would only need to run the upgrade-db-to-1.7.sql script.
+    <em>Be sure to use the version of the scripts from the 'build/src' directory: they
+    are customized for your installation in that directory.</em>
    </p>
   </p>
   <h2>Restart Tomcat</h2>
@@ -643,7 +685,7 @@
   Can't connect to X11 window server using 'yourservanme:0.0' as the value of the DISPLAY variable.
   <p>You should add this line: 
   <b>JAVA_OPTS="-Djava.awt.headless=true $JAVA_OPTS"</b> at the first line of
-  catalina.sh file in tomcat bin directory. The reason is that GeoServer uses X11 wondows to draw graphics.
+  catalina.sh file in tomcat bin directory. The reason is that GeoServer uses X11 windows to draw graphics.
   </p>
 
   <h2> Operating System Specific Instructions </h2>