Index: lib/style/skins/kepler/resultset.xsl
===================================================================
--- lib/style/skins/kepler/resultset.xsl	(revision 3235)
+++ lib/style/skins/kepler/resultset.xsl	(revision 3236)
@@ -83,13 +83,13 @@
 th.tablehead,
 td.text_plain
 {
-    padding: 0 0.75em;
+    padding: 0.375em 0.75em 0;
 }
 
 th.tablehead:first-child,
 td.text_plain:first-child
 {
-    padding: 0 0.375em;
+    padding: 0.375em 0.375em 0;
 }
 
 td.text_plain
@@ -102,7 +102,7 @@
     border-bottom: 1px solid #ddd;
 }
 
-tr.entry + tr + tr td
+tr.entry + tr td
 {
     border-bottom: 1px solid #066;
     padding-top: 0.375em;
@@ -109,13 +109,14 @@
     padding-bottom: 0.375em;
 }
 
-tr.entry + tr + tr td a
+.dl
 {
-    background: #eeeeee url(download.png) 2px center no-repeat;
+    background: #eeeeee url(@style-skins-path@/<xsl:value-of select="$qformat"/>/download2.png) 2px center no-repeat;
     border: 1px solid black;
     font-weight: bold;
     text-decoration: none;
     padding: 0.063em 0.375em 0.063em 20px;
+    font-size: smaller;
 }
 
         </style>
@@ -142,10 +143,12 @@
                 <th class="tablehead" style="width: 1px;">Component</th>
                 <th class="tablehead" style="width: 15em;">Author</th>
                 <th class="tablehead">Version</th>
+                <th class="tablehead"></th>
               </tr>
 
               <xsl:for-each select="resultset/document">
                 <xsl:sort select="./param[@name='/entity/@name']"/>
+                <xsl:variable name="sq">'</xsl:variable>
                 <tr class="entry">
 
                   <td class="text_plain">
@@ -154,21 +157,32 @@
 
                   <td class="text_plain" style="white-space: nowrap;">
                     <xsl:if test="./param[@name='entity/@name']!=''">
-                      <b>
+                      <b style="font-size: larger;">
                         <xsl:value-of select="./param[@name='entity/@name']"/>
                       </b>
                     </xsl:if>
                   </td>
 
-                  <!--td class="text_plain">
-                    <xsl:value-of select="./param[@name='entity/property/@name'][text()='documentation']/following-sibling::param[@name='entity/property/property/@name'][text()='author']/following-sibling::param[@name='entity/property/property/configure'][position()=1]"/>
+                  <td class="text_plain">
+                    <xsl:value-of select="./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'author', $sq, ']/configure')]"/>
                   </td>
 
                   <td class="text_plain">
-                    <xsl:value-of select="./param[@name='entity/property/@name'][text()='documentation']/following-sibling::param[@name='entity/property/property/@name'][text()='version']/following-sibling::param[@name='entity/property/property/configure'][position()=1]"/>
+                    <xsl:value-of select="./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'version', $sq, ']/configure')]"/>
                   </td>
 
-                  <xsl:if test="$enableediting = 'true'">
+                  <td class="text_plain">
+                    <a class="dl">
+                      <xsl:attribute name="href">
+                        <xsl:text>http://@server@/authority/data?lsid=</xsl:text>
+                        <xsl:value-of select="./param[@name=concat('entity/property[@name=', $sq, 'karId', $sq, ']/@value')]"/>
+                      </xsl:attribute>
+
+                      <xsl:text>Download</xsl:text>
+                    </a>
+                  </td>
+
+                  <!--xsl:if test="$enableediting = 'true'">
                     <td class="text_plain">
                       <form action="@servlet-path@" method="get">
                         <input type="hidden" name="action" value="read"/>
@@ -224,10 +238,13 @@
                 <tr>
                   <td class="text_plain"></td>
                   <td class="text_plain" colspan="6">
-                    <!--xsl:value-of select="substring(./param[@name='entity/property/@name'][text()='documentation']/following-sibling::param[@name='entity/property/property/@name'][text()='description']/following-sibling::param[@name='entity/property/property/configure'][position()=1], 0, 50)"/>
-                    <xsl:text>... [</xsl:text-->
+                    <xsl:variable name="docClip" select="substring(./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'description', $sq, ']/configure')], 0, 200)"/>
+                    <xsl:value-of select="$docClip"/>
+                    <xsl:text> </xsl:text>
+                    <xsl:value-of select="substring(./param[@name=concat('entity/property[@name=', $sq, 'documentation', $sq, ']/property[@name=', $sq, 'userLevelDocumentation', $sq, ']/configure')], 0, 200 - $docClip)"/>
+                    <xsl:text>... [</xsl:text>
 
-                    <a>
+                    <a style="font-size: smaller;">
                       <xsl:attribute name="href">
                         <xsl:text>metacat?qformat=</xsl:text>
                         <xsl:value-of select="$qformat"/>
@@ -245,23 +262,9 @@
                       <xsl:text>View Documentation</xsl:text>
                     </a>
 
-                    <!--xsl:text>]</xsl:text-->
+                    <xsl:text>]</xsl:text>
                   </td>
                 </tr>
-
-                <tr>
-                  <td class="text_plain"></td>
-                  <td class="text_plain" colspan="6">
-                    <a>
-                      <xsl:attribute name="href">
-                        <xsl:text>http://@server@/authority/data?lsid=</xsl:text>
-                        <xsl:value-of select="./param[@name='entity/property/@name'][text()='karId']/following-sibling::param[@name='entity/property/@value'][position()=1]"/>
-                      </xsl:attribute>
-
-                      <xsl:text>Download</xsl:text>
-                    </a>
-                  </td>
-                </tr>
               </xsl:for-each>
             </table>
           </xsl:if>
Index: lib/style/skins/kepler/index.html
===================================================================
--- lib/style/skins/kepler/index.html	(revision 3235)
+++ lib/style/skins/kepler/index.html	(revision 3236)
@@ -64,10 +64,11 @@
   <input name="enableediting" value="false" type="hidden">
   <input name="operator" value="UNION" type="hidden">
   <input name="returnfield" value="entity/@name" type="hidden">
-  <input name="returnfield" value="entity/property/@name" type="hidden">
-  <input name="returnfield" value="entity/property/@value" type="hidden">
-  <!--input name="returnfield" value="entity/property/property/@name" type="hidden">
-  <input name="returnfield" value="entity/property/property/configure" type="hidden"-->
+  <input name="returnfield" value="entity/property[@name='karId']/@value" type="hidden">
+  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='author']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='version']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='description']/configure" type="hidden">
+  <input name="returnfield" value="entity/property[@name='documentation']/property[@name='userLevelDocumentation']/configure" type="hidden">
   <input name="returndoctype" value="entity" type="hidden">
   <input name="returndoctype" value="kepler://kepler-project.org/kepler-moml-1.0.0" type="hidden">
   <input value="Search" type="submit">
@@ -80,8 +81,8 @@
       </menu>
   <p>&nbsp;</p>
   <li>
-  <a href="@servlet-path@?action=query&amp;operator=INTERSECT&amp;anyfield=%25&amp;qformat=kepler&amp;enableediting=false&amp;returndoctype=entity&returndoctype=kepler://kepler-project.org/kepler-moml-1.0.0&returnfield=entity/@name&returnfield=entity/property/@name&returnfield=entity/property/property/@name">Browse existing Kepler analytical components</a>
-  <!--a href="@servlet-path@?action=query&amp;operator=INTERSECT&amp;anyfield=%25&amp;qformat=kepler&amp;enableediting=false&amp;returndoctype=entity&returndoctype=kepler://kepler-project.org/kepler-moml-1.0.0&returnfield=entity/@name&returnfield=entity/property/@name&returnfield=entity/property/property/@name&returnfield=entity/property/property/configure&returnfield=entity/property/@value">Browse existing Kepler analytical components</a--><br />
+  <a href="@servlet-path@?action=query&operator=INTERSECT&qformat=kepler&enableediting=false&operator=UNION&returnfield=entity%2F%40name&returnfield=entity%2Fproperty%5B%40name%3D%27karId%27%5D%2F%40value&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27author%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27version%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27description%27%5D%2Fconfigure&returnfield=entity%2Fproperty%5B%40name%3D%27documentation%27%5D%2Fproperty%5B%40name%3D%27userLevelDocumentation%27%5D%2Fconfigure&returndoctype=entity&returndoctype=kepler%3A%2F%2Fkepler-project.org%2Fkepler-moml-1.0.0">Browse existing Kepler analytical components</a>
+  <br />
     <menu>
     Browse all existing data sets by title.  This operation can slow as the
     number of entries in the repository grows.